*
*   Rockey IV FoxPro 2.5/2.6 for DOS Sample
*

    set talk off

    load RockeyFP

    * Declare all function variables

    store  1    to  RY_FIND
    store  2    to  RY_FIND_NEXT
    store  3    to  RY_OPEN
    store  4    to  RY_CLOSE
    store  5    to  RY_READ
    store  6    to  RY_WRITE
    store  7    to  RY_RANDOM
    store  8    to  RY_SEED
    store  9    to  RY_WRITE_USERID
    store  10   to  RY_READ_USERID
    store  11   to  RY_SET_MOUDLE
    store  12   to  RY_CHECK_MOUDLE
    store  13   to  RY_WRITE_ARITHMETIC
    store  14   to  RY_CAL1
    store  15   to  RY_CAL2
    store  16   to  RY_CAL3
    store  17   to  RY_DECREASE

    * Declare all error code

    store   0   to  ERR_SUCCESS
    store   1   to  ERR_NO_PARALLEL_PORT
    store   2   to  ERR_NO_DRIVER
    store   3   to  ERR_NO_ROCKEY
    store   4   to  ERR_INVALID_PASSWORD
    store   5   to  ERR_INVALID_PASSWORD_OR_ID
    store   6   to  ERR_SETID
    store   7   to  ERR_INVALID_ADDR_OR_SIZE
    store   8   to  ERR_UNKNOWN_COMMAND
    store   9   to  ERR_NOTBELEVEL3
    store   10  to  ERR_READ
    store   11  to  ERR_WRITE
    store   12  to  ERR_RANDOM
    store   13  to  ERR_SEED
    store   14  to  ERR_CALCULATE
    store   15  to  ERR_NO_OPEN
    store   16  to  ERR_OPEN_OVERFLOW
    store   17  to  ERR_NOMORE
    store   18  to  ERR_NEED_FIND
    store   19  to  ERR_DECREASE
    store   20  to  ERR_AR_BADCOMMAND
    store   21  to  ERR_AR_UNKNOWN_OPCODE
    store   22  to  ERR_AR_WRONGBEGIN
    store   23  to  ERR_AR_WRONG_END
    store   24  to  ERR_AR_VALUEOVERFLOW
    store   65535 to  ERR_UNKNOWN
    store   256 to  ERR_RECEIVE_NULL
    store   257    to  ERR_PRNPORT_BUSY

    * params

    params = SPACE(256)
    buffer = SPACE(256)

    store   -15284 to p1
    store   -14088 to p2 
    store     1945 to p3 
    store   -15301 to p4 

    store 0 to lp1, lp2
    store 0 to handle
    store 0 to retcode
    store "hello" to buffer

    * Find Rockey

    do callrockey with RY_FIND
    if(retcode<>0)
        ?"Can't find Rockey, error code=",retcode
        return
	else
        ?"Find a Rockey, hid =", ltrim(str(lp1, 11))
	endif

    * Open Rockey

    do callrockey with RY_OPEN
    if(retcode<>0)
        ?"Open Rockey, error code=",retcode
        return
	endif

    * Write Rockey

	p1 = 3
	p2 = 5
	buffer= "Hello"
    do callrockey with RY_WRITE
    if(retcode<>0)
        ?"Write Rockey, error code=",retcode
        return
	else
        ?"Write : ", buffer
	endif

    * Read Rockey

	p1 = 3
	p2 = 5
    buffer = SPACE(256)
    do callrockey with RY_READ
    if(retcode<>0)
        ?"Read Rockey, error code=",retcode
        return
	else
        ?"Read : ", buffer
	endif

    * Rockey Random

    do callrockey with RY_RANDOM
    if(retcode<>0)
        ?"Rockey Random, error code=",retcode
        return
	else
        ?"Random : ", ltrim(str(p1))
	endif

    * Rockey Seed

    lp2 = 12345678
    do callrockey with RY_SEED
    if(retcode<>0)
        ?"Rockey Seed, error code=",retcode
        return
	else
        ?"Seed : ", ltrim(str(p1)), ltrim(str(p2)), ltrim(str(p3)), ltrim(str(p4))
	endif
	rc0 = p1
	rc1 = p2
	rc2 = p3
	rc3 = p4

    * Rockey Write UserID

    lp1 = 88888888
    do callrockey with RY_WRITE_USERID
    if(retcode<>0)
        ?"Rockey Write UserID, error code=",retcode
        return
	else
        ?"Write UserID : ", ltrim(str(lp1))
	endif

    * Rockey Read UserID

    lp1 = 0
    do callrockey with RY_READ_USERID
    if(retcode<>0)
        ?"Rockey Read UserID, error code=",retcode
        return
	else
        ?"Read UserID : ", ltrim(str(lp1))
	endif

    * Rockey Set Moudle

	p1 = 7
    p2 = 8481
	p3 = 0
    do callrockey with RY_SET_MOUDLE
    if(retcode<>0)
        ?"Can't Set Module 7, error code=",retcode
        return
	else
        ?"Set Module 7 : Pass = ", ltrim(str(p2)), "Decrease no allow"
	endif

    * Rockey Check Moudle

	p1 = 7
    do callrockey with RY_CHECK_MOUDLE
    if(retcode<>0)
        ?"Check Module 7, error code=",retcode
        return
	else
        ?"Check Module 7 : "
		if (p2<>0) 
            ??"Allow   "
		else 
            ??"No Allow   "
		endif
		if (p3<>0) 
            ??"Allow Decrease"
		else 
            ??"Not Allow Decrease"
		endif
	endif

    * Rockey Write Arthmetic 1

    p1 = 0
    buffer="H=H^H, A=A*23, F=B*17, A=A+F, A=A+G, A=A<C, A=A^D, B=B^B, C=C^C, D=D^D"
    do callrockey with RY_WRITE_ARITHMETIC
    if(retcode<>0)
        ?"Can't Write Arithmetic 1, error code=",retcode
        return
	else
        ?"Write Arthmetic 1"
	endif

    * Rockey Calculate 1

	lp1 = 0
	lp2 = 7
	p1 = 5
	p2 = 3
	p3 = 1
    p4 = 65535
    do callrockey with RY_CAL1
    if(retcode<>0)
        ?"Calculate 1, error code=",retcode
        return
	else
		?"Calculate Input: p1=5, p2=3, p3=1, p4=65535"
        ?"Result = (5*23 + 3*17 + 8481) < 1) ^ 65535 = -17295"
        ?"Calculate Output: p1=",ltrim(str(p1)),"p2=",ltrim(str(p2))," p3=",ltrim(str(p3))," p4=",ltrim(str(p4)) 
	endif

    * Rockey Write Arthmetic 2

    p1 = 10
    buffer="A=A+B, A=A+C, A=A+D, A=A+E, A=A+F, A=A+G, A=A+H"
    do callrockey with RY_WRITE_ARITHMETIC
    if(retcode<>0)
        ?"Can't Write Arithmetic 2, error code=",retcode
        return
	else
        ?"Write Arthmetic 2"
	endif

    * Rockey Calculate 2

	lp1 = 10 
    lp2 = 12345678
	p1 = 1 
	p2 = 2 
	p3 = 3 
	p4 = 4
    do callrockey with RY_CAL2
    if(retcode<>0)
        ?"Calculate 2, error code=",retcode
        return
	else
		?"Calculate Input: p1=1, p2=2, p3=3, p4=4"
        ?"Result = ",ltrim(str(rc0)),"+",ltrim(str(rc1)),"+",ltrim(str(rc2)),"+",ltrim(str(rc3)),"+ 1 + 2 + 3 + 4 =",ltrim(str(rc0+rc1+rc2+rc3+10))
        ?"Calculate Output: p1=",ltrim(str(p1)),"p2=",ltrim(str(p2))," p3=",ltrim(str(p3))," p4=",ltrim(str(p4)) 
	endif

    * Set Module 9 Decrease

	p1 = 9 
    p2 = 5 
	p3 = 1
    do callrockey with RY_SET_MOUDLE
    if(retcode<>0)
        ?"Can't Set Module 9, error code=",retcode
        return
	else
        ?"Set Module 9 : Pass = ", ltrim(str(p2)), "Decrease Allow"
	endif

    * Rockey Write Arthmetic 3

    p1 = 17
    buffer="A=E|E, B=F|F, C=G|G, D=H|H"
    do callrockey with RY_WRITE_ARITHMETIC
    if(retcode<>0)
        ?"Can't Write Arithmetic 3, error code=",retcode
        return
	else
        ?"Write Arthmetic 3"
	endif

    * Rockey Calculate 3

	lp1 = 17 
	lp2 = 6 
	p1 = 1 
	p2 = 2 
	p3 = 3 
	p4 = 4
    do callrockey with RY_CAL3
    if(retcode<>0)
        ?"Calculate 3, error code=",retcode
        return
	else
        ?"Show Module from 6: p1=",ltrim(str(p1))," p2=",ltrim(str(p2))," p3=",ltrim(str(p3))," p4=", ltrim(str(p4))
	endif

    * Decrease

    p1 = 9
    do callrockey with RY_DECREASE
    if(retcode<>0)
        ?"Can't Decrease module 9, error code=",retcode
        return
	else
        ?"Decrease module 9"
	endif

    * Rockey Calculate 3

	lp1 = 17 
	lp2 = 6 
	p1 = 1 
	p2 = 2 
	p3 = 3 
	p4 = 4
    do callrockey with RY_CAL3
    if(retcode<>0)
        ?"Calculate 3, error code=",retcode
        return
	else
        ?"Show Module from 6: p1=",ltrim(str(p1))," p2=",ltrim(str(p2))," p3=",ltrim(str(p3))," p4=", ltrim(str(p4))
	endif

    * Close Rockey

    do callrockey with RY_CLOSE
    if(retcode<>0)
        ?"Close Rockey, error code=",retcode
        return
	endif

    return

    PROCEDURE   callrockey
    PARAMETERS  fcode
    params = str(fcode, 6)+'.'+str(handle, 6)+'.'+str(lp1, 11)+'.'+str(lp2, 11)+'.'+str(p1, 6)+'.'+str(p2, 6)+'.'+str(p3, 6)+'.'+str(p4, 6)+'.'+buffer
    Call RockeyFP with params
    retcode = val(substr(params,1,6))
    handle  = val(substr(params,8,6))
    lp1     = val(substr(params,15,11))
    lp2     = val(substr(params,27,11))
    p1      = val(substr(params,39,6))
    p2      = val(substr(params,46,6))
    p3      = val(substr(params,53,6))
    p4      = val(substr(params,60,6))
    buffer  = substr(params,67, 24)

